/*
	_di32.c[pp]
	
	gdi32 wrapper
	
	history:
	1999-12-29
		Ƃ肠o܂B
	2000-01-03
		̑傫xʂł悤ɂB
		ŖÓAZ[u^[h̉ʃCAEg}VɂȂB
	2000-01-13
		LVNS3 ɂΉB
		ONE Ƃ킸ɍς݂Ȃ̂ōł݂B
	2000-01-19
		DIB_PAL_COLORS łۂȂ̂łB
		͂Ƃ AnimatePalette ܂ȊBނ
		UpdateColors 𔭍sĂ܂iojB
		pbǧȂƃ_낤B[B
	2000-02-07
		ŋ߂ ODIN ƂȂ񂩃AȂ̂ŁA܂ DIB_RGB_COLORS 
		g悤ɂB
	2000-02-16
		GRADD ʂ̑΍(StretchDIBits)B
		Ƃ Open32 (PMWINX) ̖ċCBς킩񂿂B
	2000-03-20
		PatBlt ̖i 2.01A 2.01jB
		GetRasterizerCaps, CreateFontIndirectA ̖iTo Heart 2.01jB
		i΋NɃtHgt@C悤ɂȂĂ񂾂ȂB
		GetGlyphOutLineA ܂ƏCق񂾂ȂB
		ONE ֌WƂŃCȂBǂ[ttHgł
		񂶂Hj
	
	Open32 ̃R`NVEIȃ:
	iԂ Odin Ⴍ Open32 ̃AƎvj
	
	ECreateDIBSection ō쐬 Color DIB  ExtTextOut (TextOut) Ă
	@͏ȂBCreateDIBitmap  DDB ɕ`悵Ă 
	@GetDIBits ŎĂ邵ȂBxԂłIB[II
	EGetTextMetrics sĂATEXTMETRIC  tmHeight ɂ͐l
	@ĂȂ悤iIĂ镶̑傫킩ȂjB
	ESelectObject ̖߂ĺu܂őIĂ HGDIOBJvƂƂ
	@ȂĂ͂AǂCc
	EGetObject  LOGFONT ͎Ȃ݂BԂ񑼂 HGDIOBJ ̒l
	@ƎȂ񂶂Ȃ̂ȁ[AƂ\ẑłimFjB 
	ExɂĂ͉܂B 
	EStretchDIBits/SetDIBitsToDevice  DIB_PAL_COLORS gꍇ́A
	@biClrUsed ݒ肵Ăق悳ȊB
	@iŋ߂ ODIN Ƃ܂֌WȂj
	

*/

#include <string.h>
#include "_di32.h"

static HDC		hdc23 = NULL;
static HDC		hdc20 = NULL;
static HFONT	hfont23 = NULL;
static HFONT	hfont20 = NULL;

static HBITMAP	hdib2423 = NULL;
static HBITMAP	hdib2020 = NULL;
static LPSTR	pdib2423 = NULL;
static LPSTR	pdib2020 = NULL;
static long		cbline20 = 12;
static long		cbline24 = 12;
static int		selected_font = 0;

#if defined(FORCE_DIB_RGB)
/* pbgɓꂽlĂꏊ */
static BYTE		bi_space[sizeof(BITMAPINFOHEADER) + 4 * 256];
#endif

static int		numofColors = 0;
static HDC		hdc_palette = NULL;
static HPALETTE	hpal_palette = NULL;


/*
	Open32 ł́AmN memory DC ɑ΂`悪܂ƂɂłȂ炵 
	iToolKit  Open32 Guide & Reference ɂȂ悤ȂƂĂj 
	Ȃ̂ 16colors DIB 炦B 

*/

static HBITMAP
createdib16(HDC hdc, int width, int height, LPSTR *pdib, long *cbline)
{
	HBITMAP	hbmp;
	char	dummy[sizeof(BITMAPINFOHEADER) + 4 * 16];
	LPBITMAPINFOHEADER	bi;
	LPDWORD				pal;
	BITMAP				bmp;
	int					i;
	
	memset(dummy, 0, sizeof(dummy));
	bi = (LPBITMAPINFOHEADER)dummy;
	pal = (DWORD *)(dummy + sizeof(BITMAPINFOHEADER));
	bi->biSize = sizeof(BITMAPINFOHEADER);
	bi->biWidth = width;
	bi->biHeight = height;
	bi->biPlanes = 1;
	bi->biBitCount = 4;
	bi->biCompression = BI_RGB;
	pal[0] = 0x00000000UL;
	for(i = 1; i<16; i++) {
		pal[i] = 0x00ffffffUL;
	}
	if (cbline) *cbline = ((width * 4 + 31) >> 3) & 0xfffffffcUL;
	
	hbmp = CreateDIBitmap(hdc
		,bi
		,0
		,NULL
		,(LPBITMAPINFO)bi
		,DIB_RGB_COLORS);
	
	return hbmp;
}


void
put_text(HDC hdc_org, UINT uChar, HFONT *sel_font, HBITMAP *sel_bmp, LPSTR *sel_ptr, long *sel_cbline, int width, int height, LPSTR destbuf)
{
	char	dummy[sizeof(BITMAPINFOHEADER) + 4 * 16];
	LPBITMAPINFOHEADER	bi;
	LPDWORD				pal;
	HDC		hdc, hdc2;
	HBITMAP	hbmp_prev;
	HFONT	hf_prev;
	unsigned char	uc[4];
	int		cb_uc;
	RECT	rc;
	int		i;

	rc.top = rc.left = 0;
	rc.right = width;
	rc.bottom = height;

	hdc = CreateCompatibleDC(hdc_org);
	
	if (!hdib2020) hdib2020 = createdib16(hdc, 20, 20, &pdib2020, &cbline20);
	if (!hdib2423) hdib2423 = createdib16(hdc, 23, 23, &pdib2423, &cbline24);
	
	SetTextColor(hdc, 0x00ffffffUL);
	SetBkColor(hdc, 0);
	hbmp_prev = (HBITMAP)SelectObject(hdc, *sel_bmp);
	hf_prev = (HFONT)SelectObject(hdc, *sel_font);
	
	if (uChar > 255) {
		*uc = (uChar >> 8);
		uc[1] = (unsigned char)uChar;
		cb_uc = 2;
	} else {
		*uc = (unsigned char)uChar;
		cb_uc = 1;
	}
	SetMapMode(hdc, MM_TEXT);
	SetWindowOrgEx(hdc, 0, 0, NULL);
	ExtTextOut(hdc, 0, 0, ETO_OPAQUE, &rc, uc, cb_uc, NULL);

	memset(dummy, 0, sizeof(dummy));
	bi = (LPBITMAPINFOHEADER)dummy;
	pal = (LPDWORD)(dummy + sizeof(LPBITMAPINFOHEADER));
	bi->biSize = sizeof(BITMAPINFOHEADER);
	bi->biWidth = width;
	bi->biHeight = height;
	bi->biPlanes = 1;
	bi->biBitCount = 1;
	pal[0] = 0x00000000UL;
	pal[1] = 0x00ffffffUL;
	
	bi->biBitCount = 0;
	GetDIBits(hdc, *sel_bmp, 0, height, NULL, (LPBITMAPINFO)bi, DIB_RGB_COLORS);
	bi->biWidth = width;
	bi->biHeight = height;
	bi->biBitCount = 1;
	
	GetDIBits(hdc, *sel_bmp, 0, height, destbuf, (LPBITMAPINFO)bi, DIB_RGB_COLORS);	

	SelectObject(hdc, hf_prev);
	SelectObject(hdc, hbmp_prev);

	for(i=0; i<(height / 2); i++) {	/* Ȃ蓊ȓVn] */
		BYTE	*p1, *p2;
		BYTE	b1, b2;
		
		p1 = destbuf + i * 4;
		p2 = destbuf + (height - i - 1) * 4;
		
		b1 = *p1; b2 = *p2;
		*p1 = b2; *p2 = b1;
		p1++; p2++;
		b1 = *p1; b2 = *p2;
		*p1 = b2; *p2 = b1;
		p1++; p2++;
		b1 = *p1; b2 = *p2;
		*p1 = b2; *p2 = b1;
		p1++; p2++;
	}

	DeleteDC(hdc);
}


DWORD MYEXPORT	  
expGetGlyphOutlineA(HDC hdc,
                    UINT uChar,
                    UINT uFormat,
                    LPGLYPHMETRICS lpgm,
                    DWORD cbBuf,
                    LPVOID lpvBuf,
                    CONST MAT2 *mat)
{
	DWORD	result;
	HFONT	*sel_font;
	HBITMAP	*sel_bmp;
	LPSTR	*sel_ptr;
	long	*sel_cbline;
	long	width, height;

#if 0
	result = GetGlyphOutlineA(hdc, uChar, uFormat, lpgm, cbBuf, lpvBuf, mat);
#else
	result = (DWORD)(-1L);
	
	if (uFormat == GGO_BITMAP) {
	/*
		lI memo:
		unmd`PG߂ց`vŎgĂtHg͓ނŁA
		 20dots ̂̂ 23dots ̂́Bi͖wj
		
		hdc ɂǂ̃tHgݒ肳Ă邩ŒׂׂȂ̂ 
		͈͂ł͂܂ȂBRgAEgĂ@
		{ Win32 łׂ͂Ă܂B Odin łׂ͂
		sBOdin ƂAԂ Open32 ̖肾ƎvBނB
		
		Ƃ肠Ƒȕ@őΏĂ݂BiexpSelectObject QƂ̂Ɓj
		ꉞ܂Ă悤A͂肢āAm؂́AȂB
	*/
	/*
		TEXTMETRIC	tm;
		GetTextMetrics(hdc, &tm);
		height = tm.tmHeight;
	*/
	/*
		LOGFONT	lf;
		HFONT	hfprev;
		
		lf.lfHeight = 0;
		hfprev = (HFONT)SelectObject(hdc, GetStockObject(ANSI_FIXED_FONT));
		GetObject(hfprev, sizeof(LOGFONT), &lf);
		SelectObject(hdc, hfprev);
		height = lf.lfHeight;
	*/
	/*
		HFONT	hfprev;
		hfprev = (HFONT)SelectObject(hdc, GetStockObject(ANSI_FIXED_FONT));
		SelectObject(hdc, hfprev);
		
		height = 0;
		if (hfprev == hfont20) height = 20;
		if (hfprev == hfont23) height = 23;
	*/
		if (hdc == hdc20) height = 20;
		else height = 23;
	
		switch(height) {
			case 20:
				sel_font = &hfont20;
				sel_bmp = &hdib2020;
				sel_ptr = &pdib2020;
				sel_cbline = &cbline20;
				width = height = 20;
				break;
			case 23:
			default:
				sel_font = &hfont23;
				sel_bmp = &hdib2423;
				sel_ptr = &pdib2423;
				sel_cbline = &cbline24;
				width = height = 23;
				break;
			/*
			default:
				return -1L;
			*/
		}
		
		if (uChar < 256) width = (width + 1) >> 1;
		lpgm->gmBlackBoxX = width;
		lpgm->gmBlackBoxY = height;
		lpgm->gmptGlyphOrigin.x = 0;
		lpgm->gmptGlyphOrigin.y = height - 1;
		lpgm->gmCellIncX = width;
		lpgm->gmCellIncY = 0;
		result = 4 * height;		/* 32dotsȓȂ 1line=4bytes */
		
		if (lpvBuf && cbBuf != 0) {
			memset(lpvBuf, 0, result);
			put_text(hdc, uChar, sel_font, sel_bmp, sel_ptr, sel_cbline, width, height, (LPSTR)lpvBuf);
		}
	}
#endif
	return result;
}


/*
	StretchDIBits / SetDIBitsToDevice
	
	I memo:

	BITMAPINFOHEADER  biClrUsed ݒ肳Ă΁A
	DIB_PAL_COLORS g炵Ƃ킩B
	(2000-01-18)

*/

DWORD
fix_bitmapinfo(BITMAPINFO *binfod, CONST BITMAPINFO *binfos)
{
	LPBITMAPINFOHEADER	bd, bs;
	DWORD				dwbits;
	DWORD				*ps, *pd;
	int					i;
	
	bd = (LPBITMAPINFOHEADER)binfod;
	bs = (LPBITMAPINFOHEADER)binfos;
	
	if (bs->biSize != sizeof(BITMAPINFOHEADER)) return 0;
	if (bd != bs) memcpy(bd, bs, sizeof(BITMAPINFOHEADER));
	dwbits = 0;
	
	if (bs->biClrUsed == 0) {
		switch(bs->biBitCount) {
			case 1:
			case 4:
			case 8:
				dwbits = 1 << (bs->biBitCount);
				break;
			default:
				break;
		}
		// if (dwbits == 256) dwbits = 236;
		bd->biClrUsed = dwbits;
	}
	if (bd->biClrImportant == 0) bd->biClrImportant = dwbits;
	
	if (0 < dwbits && dwbits <= 256) {
		ps = (DWORD *)(binfos->bmiColors);
		pd = (DWORD *)(binfod->bmiColors);
		if (pd != ps) memcpy(pd, ps, dwbits * 4);
/*
		for(i=0; i<dwbits; i++) {
			pd[i] = (ps[i] & 0xffff);
		}
*/
	}
	
	return dwbits;
}



int MYEXPORT	
expStretchDIBits(HDC hdc,
                 int XDest,
                 int YDest,
                 int nDestWidth,
                 int nDestHeight,
                 int XSrc,
                 int YSrc,
                 int nSrcWidth,
                 int nSrcHeight,
                 CONST VOID * lpBits,
                 CONST BITMAPINFO * lpBitsInfo,
                 UINT iUsage,
                 DWORD dwRop)
{
	int		result;

#if defined(FORCE_DIB_RGB)
	if (iUsage != 0) {		/* for LVNS3... */
		iUsage = 0;			/* DIB_RGB_COLORS */
		memcpy(bi_space, lpBitsInfo, sizeof(BITMAPINFOHEADER));
		lpBitsInfo = (LPBITMAPINFO)bi_space;
	}
#endif

	fix_bitmapinfo((BITMAPINFO *)lpBitsInfo, lpBitsInfo);
	
#if 0
	/*	ƑȍiقƂǌڂȂj */
	if (lpBitsInfo->bmiHeader.biWidth < nDestWidth)
		nDestWidth = lpBitsInfo->bmiHeader.biWidth;
	if (lpBitsInfo->bmiHeader.biHeight < nDestHeight)
		nDestHeight = lpBitsInfo->bmiHeader.biHeight;
#endif

#if defined(ADJUST_DIB_TOP)
	/*
		lI memo (2000-02-16) :
		]̑Ŝł͂Ȃꕔ StretchDIBits ꍇAGRADD f 
		fBXvChCoƁAԈ]Rs[Ă܂
		悤łBmȂƂ͂ЂƂ킩ȂADIB W
		VntɂȂĂ悤ȋCB
		GRADD ̃oOȁ[ƂuvǁAfBXvChCo
		oOƂ班XvIɉ߂̂ŁAOpen32 (PMWINX) ̖
		ȂcȂǂƖӔCɏĂ݂B{͂ǂȂ̂B
	*/
	if (YSrc >= 0 && nSrcHeight > 0 && (YSrc + nSrcHeight) <= lpBitsInfo->bmiHeader.biHeight)
	{
		result = StretchDIBits(hdc, XDest, YDest, nDestWidth, nDestHeight
						, XSrc
						, lpBitsInfo->bmiHeader.biHeight - YSrc - nSrcHeight
						, nSrcWidth, nSrcHeight
						, lpBits
						, lpBitsInfo, iUsage, dwRop
						);
	} else {
		result = StretchDIBits(hdc, XDest, YDest, nDestWidth, nDestHeight,
		                       XSrc, YSrc, nSrcWidth, nSrcHeight,
		                       lpBits, 
		                       (BITMAPINFO *)lpBitsInfo, iUsage, dwRop);
	}
		
#else
	result = StretchDIBits(hdc, XDest, YDest, nDestWidth, nDestHeight,
	                       XSrc, YSrc, nSrcWidth, nSrcHeight,
	                       lpBits, 
	                       (BITMAPINFO *)lpBitsInfo, iUsage, dwRop);
#endif

#if defined(DEBUG)
	{
		static DWORD	cnt;
		char	s[256];
		DWORD	*pal = (DWORD *)(lpBitsInfo->bmiColors);
		LPBITMAPINFOHEADER bi = (LPBITMAPINFOHEADER)lpBitsInfo;
		
		wsprintf(s, ""
			 "%10u "
			 "DIB %dx%d (%d,%d) %dx%d -> (%d,%d) %dx%d"
			 "  RC %d"
			, cnt++
			, bi->biWidth, bi->biHeight
			, XSrc, YSrc, nSrcWidth, nSrcHeight
			, XDest, YDest, nDestWidth, nDestHeight
			, result);
		
		TextOut(hdc, 0, 0, s, lstrlen(s));
	}
#endif

	return result;
}


int MYEXPORT
expSetDIBitsToDevice(HDC hdc
					, int XDest
					, int YDest
					, DWORD nDestWidth
					, DWORD nDestHeight
					, int XSrc
					, int YSrc
					, UINT nStartScan
					, UINT cScanLines
					, CONST VOID * lpBits
					, CONST BITMAPINFO *lpBitsInfo
					, UINT iUsage)
{
	int		result;
	
#if defined(FORCE_DIB_RGB)
	if (iUsage != 0) {		/* for LVNS3... */
		iUsage = 0;			/* DIB_RGB_COLORS */
		memcpy(bi_space, lpBitsInfo, sizeof(BITMAPINFOHEADER));
		lpBitsInfo = (LPBITMAPINFO)bi_space;
	}
#endif

	fix_bitmapinfo((BITMAPINFO *)lpBitsInfo, lpBitsInfo);

#if 1
	result = SetDIBitsToDevice(hdc, XDest, YDest, nDestWidth, nDestHeight
							, XSrc, YSrc, nStartScan, cScanLines
							, lpBits
							, (BITMAPINFO *)lpBitsInfo
							, iUsage);
#else
	{
		static long cnt = 0;
		LPBITMAPINFOHEADER	bi = (LPBITMAPINFOHEADER)tbi;
		
		cnt++;
		if (cnt < 10) {
			char	s[256];
			wsprintf(s
				, "DIB %dx%d\r"
				  "(%dx%d) w %d  h %d\r"
				  "Start %d  lines %d\r"
				, bi->biWidth, bi->biHeight
				, XDest, YDest, nDestWidth, nDestHeight
				, nStartScan, cScanLines
				);
			MessageBox(NULL, s, "SetDIBitsToDevice", MB_OK);
		}
		
		// bi->biWidth = nDestWidth;
		// bi->biHeight = nDestHeight;
		
		result = StretchDIBits(hdc
							, XDest, YDest
							, nDestWidth, nDestHeight
							, 0, 0
							, nDestWidth, nDestHeight
							, lpBits
							, (BITMAPINFO *)tbi
							, iUsage
							, SRCCOPY
							);
		
	}
#endif

#ifdef DEBUG
	{
		static DWORD	cnt;
		char	s[256];
		DWORD	*pal = (DWORD *)(lpBitsInfo->bmiColors);
		LPBITMAPINFOHEADER bi = (LPBITMAPINFOHEADER)lpBitsInfo;
		
		wsprintf(s, "SetDIBitsToDev "
			 "%10u "
			 "(%d,%d) Start %d Lines %d -> (%d,%d) w %d h %d "
			 " result %d"
			, cnt++
			, XSrc, YSrc, nStartScan, cScanLines
			, XDest, YDest, nDestWidth, nDestHeight
			, result);
		
		TextOut(hdc, 0, 24, s, lstrlen(s));
	}
#endif
	
	return result;
}


int MYEXPORT
expSetStretchBltMode(HDC hdc, int mode)
{
	return SetStretchBltMode(hdc, mode);
}


HGDIOBJ MYEXPORT	
expSelectObject(HDC hdc, HGDIOBJ hgdiobj)
{
	static HGDIOBJ	hfprev;
	HGDIOBJ		rc;
	
	if (hgdiobj == hfont20 && hfont20 != NULL) {
		selected_font = 20;
		hdc20 = hdc;
		SelectObject(hdc, hgdiobj);
		rc = hfprev;
		hfprev = hgdiobj;
	}
	else if (hgdiobj == hfont23 && hfont23 != NULL) {
		selected_font = 23;
		hdc23 = hdc;
		SelectObject(hdc, hgdiobj);
		rc = hfprev;
		hfprev = hgdiobj;
	}
	else rc = SelectObject(hdc, hgdiobj);
	
	return rc;
}


BOOL MYEXPORT	
expDeleteObject(HGDIOBJ hgdiobj)
{
	return DeleteObject(hgdiobj);
}

HGDIOBJ MYEXPORT	
expGetStockObject(int fnObj)
{
	return GetStockObject(fnObj);
}


int MYEXPORT	
expGetDeviceCaps(HDC hdc, int nIndex)
{
	int		result;
	
	result = GetDeviceCaps(hdc, nIndex);
	if (numofColors == 0) {
		numofColors = GetDeviceCaps(hdc, NUMCOLORS);
	}
	return result;
}


int MYEXPORT	
expEnumFontFamiliesA(HDC hdc,
                    LPCSTR lpszFamily,
                    FONTENUMPROC lpfnProc,
                    LPARAM lprm)
{
	return EnumFontFamiliesA(hdc, lpszFamily, lpfnProc, lprm);
}


HFONT MYEXPORT	
expCreateFontA(int nHeight,
              int nWidth,
              int nEsc,
              int nOrient,
              int fnWeight,
              DWORD fdwItalic,
              DWORD fdwUnderLine,
              DWORD fdwStrike,
              DWORD fdwCharSet,
              DWORD fdwPrecis,
              DWORD fdwClipPrecis,
              DWORD fdwQuality,
              DWORD fdwPitchFamily,
              LPCSTR lpszFace)
{
	HFONT	result, hf;

	result = CreateFontA(nHeight, nWidth, nEsc, nOrient, fnWeight,
	                        fdwItalic, fdwUnderLine, fdwStrike,
	                        fdwCharSet,
	                        fdwPrecis, fdwClipPrecis,
	                        fdwQuality,
	                        fdwPitchFamily,
	                        lpszFace);

#ifdef DEBUG
	{
		char	s[256];
		
		wsprintf(s
			, "%dx%d %s"
			, nWidth, nHeight
			, lpszFace
			);
		MessageBox(NULL, s, "CreateFontA", MB_OK);
	}
#endif

	if (result) {		/* for ONE */
		if (nHeight == 20) { hfont20 = result; }
		if (nHeight == 23) { hfont23 = result; }
	}
	
	return result;
}



/*
	pick PALETTE value...
	
	DIB_PAL_COLORS gȂꍇ̂߂ɁApbgɓ˂ł RGB l
	ĎĂBƁijBȂ񂩓Ă炵ǁB
	
	ǁ[ł RGBQUAD  PALETTEENTRY  RGB ̕тr~[
	Ⴄ񂾂ȂBDWORD ɃLXgđłȂBB
*/


HPALETTE MYEXPORT
expCreatePalette(CONST LOGPALETTE *logpal)
{
	HPALETTE	result;

	result = CreatePalette(logpal);

#if defined(FORCE_DIB_RGB)
	if (result) {
		int		i;
		PALETTEENTRY	*ps;
		RGBQUAD			*pd;
		ps = (PALETTEENTRY *)(logpal->palPalEntry);
		pd = (RGBQUAD *)(bi_space + sizeof(BITMAPINFOHEADER));
		for(i=0; i < logpal->palNumEntries; i++) {
			pd[i].rgbRed = ps[i].peRed;
			pd[i].rgbGreen = ps[i].peGreen;
			pd[i].rgbBlue = ps[i].peBlue;
		}
	}
#endif
	
	return result;
}


BOOL MYEXPORT
expSetPaletteEntries(HPALETTE hpal, UINT idx, UINT ent, CONST PALETTEENTRY *pe)
{
	int	result;

	result = SetPaletteEntries(hpal, idx, ent, pe);

#if defined(FORCE_DIB_RGB)
	if (result) {
		// int		i = result;
		int		i = ent;
		RGBQUAD	*pd;
		pd = (RGBQUAD *)(bi_space + sizeof(BITMAPINFOHEADER));
		pd += idx;
		while(i--) {
			pd->rgbRed = pe->peRed;
			pd->rgbGreen = pe->peGreen;
			pd->rgbBlue = pe->peBlue;
			pe++;
			pd++;
		}
	}
#endif

	return (BOOL)result;
}


BOOL MYEXPORT
expAnimatePalette(HPALETTE hpal, UINT idx, UINT ent, CONST PALETTEENTRY *pe)
{
	BOOL	result;

	result = AnimatePalette(hpal, idx, ent, pe);
	
	if (result) {
#if defined(FORCE_DIB_RGB)
		int		i = ent;
		RGBQUAD	*pd;
		
		pd = (RGBQUAD *)(bi_space + sizeof(BITMAPINFOHEADER));
		pd += idx;
		while(i--) {
			if ((pe->peFlags & PC_EXPLICIT) == 0) {
				pd->rgbRed = pe->peRed;
				pd->rgbGreen = pe->peGreen;
				pd->rgbBlue = pe->peBlue;
			}
			pe++;
			pd++;
		}
#endif
		/* for LVNS3...
		
			ǂ AnimatePalette ̌ÂƂÂ܂܂
			ÑSGfBÕX^btƂƏoȂB
			Ƃ肠ƑȎiőΉĂ݂Bł{ hdc_palette 
			Lǂ킩Ȃ̂ŃoiہAoȂƂ͏oȂjB
			܂͂Ȃ̂ł̂܂ܓĂB
			
			Ȃ킯Ōł͂QTUF[hł̗p߂łȂB
		*/
		if (hpal == hpal_palette && (numofColors == 256)) {
			UpdateColors(hdc_palette);
		}
	}

	return result;
}


UINT MYEXPORT
expRealizePalette(HDC hdc)
{
	return RealizePalette(hdc);
}

HPALETTE MYEXPORT
expSelectPalette(HDC hdc, HPALETTE hpal, BOOL bg)
{
	HPALETTE	result;
	
	result = SelectPalette(hdc, hpal, bg);

	if (result) {
		hdc_palette = hdc;
		hpal_palette = hpal;
	}
	return result;
}

BOOL MYEXPORT
expUpdateColors(HDC hdc)
{
	return UpdateColors(hdc);
}


BOOL MYEXPORT
expGetTextMetricsA(HDC hdc, LPTEXTMETRICA lptm)
{
	BOOL	result;
	
	result = GetTextMetricsA(hdc, lptm);
	return result;
}


BOOL MYEXPORT
expPatBlt(HDC hdc, int left, int top, int width, int height, DWORD rop)
{
	BOOL	result;
	
	result = PatBlt(hdc, left, top, width, height, rop);
	return result;
}

BOOL MYEXPORT
expGetRasterizerCaps(LPRASTERIZER_STATUS rs, UINT cb)
{
	BOOL	result;
	
	result = GetRasterizerCaps(rs, cb);
	return result;
}

HFONT MYEXPORT
expCreateFontIndirectA(CONST LOGFONTA *lf)
{
	HFONT	hf;
	
	hf = CreateFontIndirectA(lf);
	return hf;
}
