/*
	_di32.h

	gdi32 forwarder
*/

#ifndef _di32_h__
#define _di32_h__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#if defined(__WATCOMC__)
#define MYEXPORT	
#define MY_EXPORT
#pragma aux _myexp_watcom "*" parm routine [] value struct struct caller [] modify [eax ecx edx];
#define MYIMPORT
#pragma aux _myimp_watcom "*" parm routine [] value struct struct caller [] modify [eax ecx edx];

#else
#define MYEXPORT __stdcall
#define MY_EXPORT
#define MYIMPORT __stdcall
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
    StretchDIBits
    SelectObject
    GetGlyphOutlineA
    DeleteObject
    GetStockObject
    GetDeviceCaps
    EnumFontFamiliesA
    CreateFontA

	CreatePalette
	AnimatePalette
	RealizePalette
	SelectPalette
	SetPaletteEntries
	UpdateColors

	SetDIBitsToDevice
	SetStretchBltMode
	
	GetTextMetricsA
	
	PatBlt
*/


MY_EXPORT
int MYEXPORT	expStretchDIBits(HDC, int, int, int, int, int, int, int, int,
	CONST VOID *, CONST BITMAPINFO *, UINT, DWORD);

MY_EXPORT
HGDIOBJ MYEXPORT	expSelectObject(HDC, HGDIOBJ);

MY_EXPORT
DWORD MYEXPORT	 expGetGlyphOutlineA(HDC, UINT, UINT, LPGLYPHMETRICS, DWORD, LPVOID, CONST MAT2 *);

MY_EXPORT
BOOL MYEXPORT	expDeleteObject(HGDIOBJ);

MY_EXPORT
HGDIOBJ MYEXPORT	expGetStockObject(int);

MY_EXPORT
int MYEXPORT	expGetDeviceCaps(HDC, int);

MY_EXPORT
int MYEXPORT	expEnumFontFamiliesA(HDC, LPCSTR, FONTENUMPROC, LPARAM);

MY_EXPORT
HFONT MYEXPORT	expCreateFontA(int, int, int, int, int, DWORD,
                               DWORD, DWORD, DWORD, DWORD, DWORD,
                               DWORD, DWORD, LPCSTR);



MY_EXPORT
HPALETTE MYEXPORT	expCreatePalette(CONST LOGPALETTE *);

MY_EXPORT
UINT MYEXPORT	expRealizePalette(HDC);

MY_EXPORT
HPALETTE MYEXPORT	expSelectPalette(HDC, HPALETTE, BOOL);

MY_EXPORT
BOOL MYEXPORT	expAnimatePalette(HPALETTE, UINT, UINT, CONST PALETTEENTRY *);

MY_EXPORT
BOOL MYEXPORT	expSetPaletteEntries(HPALETTE, UINT, UINT, CONST PALETTEENTRY *);

MY_EXPORT
BOOL MYEXPORT	expUpdateColors(HDC);


MY_EXPORT
int MYEXPORT	expSetDIBitsToDevice(HDC, int, int, DWORD, DWORD, int, int, UINT, UINT, CONST VOID *, CONST BITMAPINFO *, UINT);

MY_EXPORT
int MYEXPORT	expSetStretchBltMode(HDC, int);

MY_EXPORT
BOOL MYEXPORT	expGetTextMetricsA(HDC, LPTEXTMETRICA);


MY_EXPORT
BOOL MYEXPORT	expPatBlt(HDC, int, int, int, int, DWORD);

MY_EXPORT
BOOL MYEXPORT	expGetRasterizerCaps(LPRASTERIZER_STATUS, UINT);

MY_EXPORT
HFONT MYEXPORT	expCreateFontIndirectA(CONST LOGFONTA *);

#if defined(__WATCOMC__)
#pragma aux (_myexp_watcom) expStretchDIBits;
#pragma aux (_myexp_watcom) expSelectObject;
#pragma aux (_myexp_watcom) expGetGlyphOutlineA;
#pragma aux (_myexp_watcom) expDeleteObject;
#pragma aux (_myexp_watcom) expGetStockObject;
#pragma aux (_myexp_watcom) expGetDeviceCaps;
#pragma aux (_myexp_watcom) expEnumFontFamiliesA;
#pragma aux (_myexp_watcom) expCreateFontA;

#pragma aux (_myexp_watcom)	expCreatePalette;
#pragma aux (_myexp_watcom)	expAnimatePalette;
#pragma aux (_myexp_watcom)	expRealizePalette;
#pragma aux (_myexp_watcom)	expSelectPalette;
#pragma aux (_myexp_watcom)	expSetPaletteEntries;
#pragma aux (_myexp_watcom)	expUpdateColors;

#pragma aux (_myexp_watcom)	expSetDIBitsToDevice;
#pragma aux (_myexp_watcom)	expSetStretchBltMode;

#pragma aux (_myexp_watcom)	expGetTextMetricsA;

#pragma aux (_myexp_watcom)	expPatBlt;
#pragma aux (_myexp_watcom)	expGetRasterizerCaps;
#pragma aux (_myexp_watcom)	expCreateFontIndirectA;
#endif

#ifdef __cplusplus
}
#endif


#endif
